<?php

namespace dgsoft\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfImageItemsTypeImageItem ArrayType
 * @package Dg
 * @subpackage Arrays
 */
class DgArrayOfImageItemsTypeImageItem extends AbstractStructArrayBase
{
    /**
     * The ImageItemsTypeImageItem
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \dgsoft\StructType\DgImageItemsTypeImageItem[]
     */
    public $ImageItemsTypeImageItem;
    /**
     * Constructor method for ArrayOfImageItemsTypeImageItem
     * @uses DgArrayOfImageItemsTypeImageItem::setImageItemsTypeImageItem()
     * @param \dgsoft\StructType\DgImageItemsTypeImageItem[] $imageItemsTypeImageItem
     */
    public function __construct(array $imageItemsTypeImageItem = array())
    {
        $this
            ->setImageItemsTypeImageItem($imageItemsTypeImageItem);
    }
    /**
     * Get ImageItemsTypeImageItem value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \dgsoft\StructType\DgImageItemsTypeImageItem[]|null
     */
    public function getImageItemsTypeImageItem()
    {
        return isset($this->ImageItemsTypeImageItem) ? $this->ImageItemsTypeImageItem : null;
    }
    /**
     * Set ImageItemsTypeImageItem value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \dgsoft\StructType\DgImageItemsTypeImageItem[] $imageItemsTypeImageItem
     * @return \dgsoft\ArrayType\DgArrayOfImageItemsTypeImageItem
     */
    public function setImageItemsTypeImageItem(array $imageItemsTypeImageItem = array())
    {
        foreach ($imageItemsTypeImageItem as $arrayOfImageItemsTypeImageItemImageItemsTypeImageItemItem) {
            // validation for constraint: itemType
            if (!$arrayOfImageItemsTypeImageItemImageItemsTypeImageItemItem instanceof \dgsoft\StructType\DgImageItemsTypeImageItem) {
                throw new \InvalidArgumentException(sprintf('The ImageItemsTypeImageItem property can only contain items of \dgsoft\StructType\DgImageItemsTypeImageItem, "%s" given', is_object($arrayOfImageItemsTypeImageItemImageItemsTypeImageItemItem) ? get_class($arrayOfImageItemsTypeImageItemImageItemsTypeImageItemItem) : gettype($arrayOfImageItemsTypeImageItemImageItemsTypeImageItemItem)), __LINE__);
            }
        }
        if (is_null($imageItemsTypeImageItem) || (is_array($imageItemsTypeImageItem) && empty($imageItemsTypeImageItem))) {
            unset($this->ImageItemsTypeImageItem);
        } else {
            $this->ImageItemsTypeImageItem = $imageItemsTypeImageItem;
        }
        return $this;
    }
    /**
     * Add item to ImageItemsTypeImageItem value
     * @throws \InvalidArgumentException
     * @param \dgsoft\StructType\DgImageItemsTypeImageItem $item
     * @return \dgsoft\ArrayType\DgArrayOfImageItemsTypeImageItem
     */
    public function addToImageItemsTypeImageItem(\dgsoft\StructType\DgImageItemsTypeImageItem $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \dgsoft\StructType\DgImageItemsTypeImageItem) {
            throw new \InvalidArgumentException(sprintf('The ImageItemsTypeImageItem property can only contain items of \dgsoft\StructType\DgImageItemsTypeImageItem, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->ImageItemsTypeImageItem[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \dgsoft\StructType\DgImageItemsTypeImageItem|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \dgsoft\StructType\DgImageItemsTypeImageItem|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \dgsoft\StructType\DgImageItemsTypeImageItem|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \dgsoft\StructType\DgImageItemsTypeImageItem|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \dgsoft\StructType\DgImageItemsTypeImageItem|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ImageItemsTypeImageItem
     */
    public function getAttributeName()
    {
        return 'ImageItemsTypeImageItem';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \dgsoft\ArrayType\DgArrayOfImageItemsTypeImageItem
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
